diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/qos-txop.h ns-3.31/src/wifi/model/qos-txop.h
--- ns-3.30.1/src/wifi/model/qos-txop.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/qos-txop.h	2020-06-27 17:38:30.000000000 -0700
@@ -39,6 +39,7 @@
 class MgtDelBaHeader;
 class AggregationCapableTransmissionListener;
 class WifiTxVector;
+class WifiAckPolicySelector;
 
 /**
  * Enumeration for type of station
@@ -67,10 +68,10 @@
  *
  * This queue contains packets for a particular access class.
  * Possibles access classes are:
- *   - AC_VO : voice, tid = 6,7
- *   - AC_VI : video, tid = 4,5
- *   - AC_BE : best-effort, tid = 0,3
- *   - AC_BK : background, tid = 1,2
+ *   - AC_VO : voice, TID = 6,7
+ *   - AC_VI : video, TID = 4,5
+ *   - AC_BE : best-effort, TID = 0,3
+ *   - AC_BK : background, TID = 1,2
  *
  * This class also implements block ack sessions and MSDU aggregation (A-MSDU).
  * If A-MSDU is enabled for that access class, it picks several packets from the
@@ -82,18 +83,20 @@
  *
  * The retransmission policy is also very simple: every packet is
  * retransmitted until it is either successfully transmitted or
- * it has been retransmitted up until the ssrc or slrc thresholds.
+ * it has been retransmitted up until the SSRC or SLRC thresholds.
  *
- * The rts/cts policy is similar to the fragmentation policy: when
- * a packet is bigger than a threshold, the rts/cts protocol is used.
+ * The RTS/CTS policy is similar to the fragmentation policy: when
+ * a packet is bigger than a threshold, the RTS/CTS protocol is used.
  */
 
 class QosTxop : public Txop
 {
 public:
-  /// Allow test cases to access private members
+  /// allow AmpduAggregationTest class access
   friend class ::AmpduAggregationTest;
+  /// allow TwoLevelAggregationTest class access
   friend class ::TwoLevelAggregationTest;
+  /// allow HeAggregationTest class access
   friend class ::HeAggregationTest;
 
   std::map<Mac48Address, bool> m_aMpduEnabled; //!< list containing flags whether A-MPDU is enabled for a given destination address
@@ -107,19 +110,37 @@
   QosTxop ();
   virtual ~QosTxop ();
 
+  // Overridden from Txop
+  bool IsQosTxop (void) const;
+  void SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> remoteManager);
+  virtual bool HasFramesToTransmit (void);
+  void NotifyAccessGranted (void);
+  void NotifyInternalCollision (void);
+  void GotAck (void);
+  void GotBlockAck (const CtrlBAckResponseHeader *blockAck, Mac48Address recipient,
+                    double rxSnr, double dataSnr, WifiTxVector dataTxVector);
+  void MissedBlockAck (uint8_t nMpdus);
+  void MissedAck (void);
+  void StartNextPacket (void);
+  void EndTxNoAck (void);
+  void RestartAccessIfNeeded (void);
+  void StartAccessIfNeeded (void);
+  Time GetTxopRemaining (void) const;
+  bool NeedFragmentation (void) const;
+  Ptr<Packet> GetFragmentPacket (WifiMacHeader *hdr);
+
   /**
-   * Check for QoS TXOP.
+   * Set the ack policy selector.
    *
-   * \returns true if QoS TXOP.
+   * \param ackSelector the ack policy selector.
    */
-  bool IsQosTxop (void) const;
-
+  void SetAckPolicySelector (Ptr<WifiAckPolicySelector> ackSelector);
   /**
-   * Set WifiRemoteStationsManager this QosTxop is associated to.
+   * Return the ack policy selector.
    *
-   * \param remoteManager WifiRemoteStationManager.
+   * \return the ack policy selector.
    */
-  void SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> remoteManager);
+  Ptr<WifiAckPolicySelector> GetAckPolicySelector (void) const;
   /**
    * Set type of station with the given type.
    *
@@ -140,17 +161,17 @@
    * \return true if a block ack agreement is established, false otherwise.
    *
    * Checks if a block ack agreement is established with station addressed by
-   * <i>recipient</i> for tid <i>tid</i>.
+   * <i>recipient</i> for TID <i>tid</i>.
    */
   bool GetBaAgreementEstablished (Mac48Address address, uint8_t tid) const;
   /**
    * \param address recipient address of the peer station
    * \param tid traffic ID.
    *
-   * \return the negociated buffer size during ADDBA handshake.
+   * \return the negotiated buffer size during ADDBA handshake.
    *
-   * Returns the negociated buffer size during ADDBA handshake with station addressed by
-   * <i>recipient</i> for tid <i>tid</i>.
+   * Returns the negotiated buffer size during ADDBA handshake with station addressed by
+   * <i>recipient</i> for TID <i>tid</i>.
    */
   uint16_t GetBaBufferSize (Mac48Address address, uint8_t tid) const;
   /**
@@ -160,24 +181,28 @@
    * \return the starting sequence number of the originator transmit window.
    *
    * Returns the current starting sequence number of the transmit window on the
-   * originator (WinStartO) of the Block Ack agreement established with the given
+   * originator (WinStartO) of the block ack agreement established with the given
    * recipient for the given TID.
    */
   uint16_t GetBaStartingSequence (Mac48Address address, uint8_t tid) const;
-
-  /* dcf notifications forwarded here */
-  /**
-   * Notify the EDCAF that access has been granted.
-   */
-  void NotifyAccessGranted (void);
   /**
-   * Notify the EDCAF that internal collision has occurred.
+   * \param address recipient address
+   * \param tid traffic ID
+   *
+   * Prepare a BlockAckRequest to be sent to <i>recipient</i> for Traffic ID
+   * <i>tid</i>. The header for the BlockAckRequest is requested to the QosTxop
+   * corresponding to the given TID. A block ack agreement with the given recipient
+   * for the given TID must have been established by such QosTxop.
    */
-  void NotifyInternalCollision (void);
+  Ptr<const WifiMacQueueItem> PrepareBlockAckRequest (Mac48Address recipient, uint8_t tid) const;
   /**
-   * Notify the EDCAF that collision has occurred.
+   * \param bar the BlockAckRequest to schedule
+   * \param skipIfNoDataQueued do not send if there is no data queued
+   *
+   * Request the block ack manager to schedule the transmission of the given
+   * BlockAckRequest.
    */
-  void NotifyCollision (void);
+  void ScheduleBar (Ptr<const WifiMacQueueItem> bar, bool skipIfNoDataQueued = false);
 
   /* Event handlers */
   /**
@@ -186,25 +211,7 @@
    * \param mpduList the list of MPDUs that were not transmitted
    */
   void NotifyMissedCts (std::list<Ptr<WifiMacQueueItem>> mpduList);
-  /**
-   * Event handler when an ACK is received.
-   */
-  void GotAck (void);
-  /**
-   * Event handler when a Block ACK is received.
-   *
-   * \param blockAck block ack.
-   * \param recipient address of the recipient.
-   * \param rxSnr SNR of the block ack itself.
-   * \param txMode wifi mode.
-   * \param dataSnr reported data SNR from the peer.
-   */
-  void GotBlockAck (const CtrlBAckResponseHeader *blockAck, Mac48Address recipient, double rxSnr, WifiMode txMode, double dataSnr);
-  /**
-   * Event handler when a Block ACK timeout has occurred.
-   * \param nMpdus number of MPDUs sent in the A-MPDU transmission that results in a Block ACK timeout.
-   */
-  void MissedBlockAck (uint8_t nMpdus);
+
   /**
    * Event handler when an ADDBA response is received.
    *
@@ -219,30 +226,9 @@
    * \param recipient address of the recipient.
    */
   void GotDelBaFrame (const MgtDelBaHeader *delBaHdr, Mac48Address recipient);
-  /**
-   * Event handler when an ACK is missed.
-   */
-  void MissedAck (void);
-
-  /**
-   * Start transmission for the next packet if allowed by the TxopLimit.
-   */
-  void StartNextPacket (void);
-  /**
-   * Event handler when a transmission that does not require an ACK has completed.
-   */
-  void EndTxNoAck (void);
-  /**
-   * Restart access request if needed.
-   */
-  void RestartAccessIfNeeded (void);
-  /**
-   * Request access from DCF manager if needed.
-   */
-  void StartAccessIfNeeded (void);
 
   /**
-   * Check if Block ACK Request should be re-transmitted.
+   * Check if BlockAckRequest should be re-transmitted.
    *
    * \return true if BAR should be re-transmitted,
    *         false otherwise.
@@ -250,24 +236,6 @@
   bool NeedBarRetransmission (void);
 
   /**
-   * Check if the current packet should be fragmented.
-   *
-   * \return true if the current packet should be fragmented,
-   *         false otherwise.
-   */
-  bool NeedFragmentation (void) const;
-
-  /**
-   * Get the next fragment from the packet with
-   * appropriate Wifi header for the fragment.
-   *
-   * \param hdr Wi-Fi header.
-   *
-   * \return the fragment with the current fragment number.
-   */
-  Ptr<Packet> GetFragmentPacket (WifiMacHeader *hdr);
-
-  /**
    * Set the access category of this EDCAF.
    *
    * \param ac access category.
@@ -284,33 +252,33 @@
   void PushFront (Ptr<const Packet> packet, const WifiMacHeader &hdr);
 
   /**
-   * Complete block ACK configuration.
+   * Complete block ack configuration.
    */
   void CompleteConfig (void);
 
   /**
-   * Set threshold for block ACK mechanism. If number of packets in the
-   * queue reaches the threshold, block ACK mechanism is used.
+   * Set threshold for block ack mechanism. If number of packets in the
+   * queue reaches the threshold, block ack mechanism is used.
    *
    * \param threshold block ack threshold value.
    */
   void SetBlockAckThreshold (uint8_t threshold);
   /**
-   * Return the current threshold for block ACK mechanism.
+   * Return the current threshold for block ack mechanism.
    *
-   * \return the current threshold for block ACK mechanism.
+   * \return the current threshold for block ack mechanism.
    */
   uint8_t GetBlockAckThreshold (void) const;
 
   /**
-   * Set the Block Ack inactivity timeout.
+   * Set the BlockAck inactivity timeout.
    *
-   * \param timeout the Block Ack inactivity timeout.
+   * \param timeout the BlockAck inactivity timeout.
    */
   void SetBlockAckInactivityTimeout (uint16_t timeout);
   /**
-   * Sends DELBA frame to cancel a block ack agreement with sta
-   * addressed by <i>addr</i> for tid <i>tid</i>.
+   * Sends DELBA frame to cancel a block ack agreement with STA
+   * addressed by <i>addr</i> for TID <i>tid</i>.
    *
    * \param addr address of the recipient.
    * \param tid traffic ID.
@@ -318,9 +286,8 @@
    */
   void SendDelbaFrame (Mac48Address addr, uint8_t tid, bool byOriginator);
   /**
-   * Stores an MPDU (part of an A-MPDU) in blockackagreement (i.e. the sender is waiting
-   * for a blockack containing the sequence number of this MPDU).
-   * It also calls NotifyMpdu transmission that updates the status of OriginatorBlockAckAgreement.
+   * Stores an MPDU (part of an A-MPDU) in block ack agreement (i.e. the sender is waiting
+   * for a BlockAck containing the sequence number of this MPDU).
    *
    * \param mpdu received MPDU.
    */
@@ -383,7 +350,7 @@
   uint16_t PeekNextSequenceNumberFor (const WifiMacHeader *hdr);
   /**
    * Peek the next frame to transmit to the given receiver and of the given
-   * TID from the Block Ack manager retransmit queue first and, if not found, from
+   * TID from the block ack manager retransmit queue first and, if not found, from
    * the EDCA queue. If <i>tid</i> is equal to 8 (invalid value) and <i>recipient</i>
    * is the broadcast address, the first available frame is returned.
    * Note that A-MSDU aggregation is never attempted (this is relevant if the
@@ -396,25 +363,26 @@
    */
   Ptr<const WifiMacQueueItem> PeekNextFrame (uint8_t tid = 8, Mac48Address recipient = Mac48Address::GetBroadcast ());
   /**
-   * Dequeue the frame that has been previously peeked by calling PeekNextFrame
-   * or PeekNextFrameByTidAndAddress. If the peeked frame is a QoS Data frame,
-   * it is actually dequeued if it meets the constraint on the maximum A-MPDU
-   * size (by assuming that the frame has to be aggregated to an existing A-MPDU
-   * of the given size) and its transmission time does not exceed the given
-   * PPDU duration limit (if strictly positive). If the peeked frame is a unicast
-   * QoS Data frame stored in the EDCA queue, attempt to perform A-MSDU aggregation
-   * (while meeting the constraints mentioned above) if <i>aggregate</i> is true
-   * and assign a sequence number to the dequeued frame.
+   * Dequeue the frame that has been previously peeked by calling PeekNextFrame.
+   * If the peeked frame is a QoS Data frame, it is actually dequeued if it meets
+   * the constraint on the maximum A-MPDU size (by assuming that the frame has to
+   * be aggregated to an existing A-MPDU of the given size) and its transmission
+   * time does not exceed the given PPDU duration limit (if distinct from Time::Min ()).
+   * If the peeked frame is a unicast QoS Data frame stored in the EDCA queue,
+   * attempt to perform A-MSDU aggregation (while meeting the constraints mentioned
+   * above) if <i>aggregate</i> is true and assign a sequence number to the
+   * dequeued frame.
    *
    * \param peekedItem the peeked frame.
    * \param txVector the TX vector used to transmit the peeked frame
-   * \param ampduSize the size of the existing A-MPDU, if any
+   * \param aggregate whether to attempt A-MSDU aggregation
+   * \param ampduSize the size of the existing A-MPDU in bytes, if any
    * \param ppduDurationLimit the limit on the PPDU duration
    * \returns the dequeued frame.
    */
   Ptr<WifiMacQueueItem> DequeuePeekedFrame (Ptr<const WifiMacQueueItem> peekedItem, WifiTxVector txVector,
                                             bool aggregate = true, uint32_t ampduSize = 0,
-                                            Time ppduDurationLimit = Seconds (0));
+                                            Time ppduDurationLimit = Time::Min ());
   /**
    * Compute the MacLow transmission parameters for the given frame. Allowed frames
    * are those handled by a QosTxop (QoS data frames, BlockAckReq frames, ADDBA
@@ -426,6 +394,14 @@
   MacLowTransmissionParameters GetTransmissionParameters (Ptr<const WifiMacQueueItem> frame) const;
 
   /**
+   * Update the current packet this QosTxop is trying to transmit. This method
+   * is typically called by MacLow when it changes (i.e., by performing A-MSDU
+   * aggregation) the packet received from this QosTxop.
+   *
+   * \param mpdu the MPDU that MacLow is forwarding down to the PHY.
+   */
+  void UpdateCurrentPacket (Ptr<WifiMacQueueItem> mpdu);
+  /**
    * The packet we sent was successfully received by the receiver.
    *
    * \param hdr the header of the packet that we successfully sent.
@@ -440,9 +416,9 @@
 
   /**
    * This functions are used only to correctly set source address in A-MSDU subframes.
-   * If aggregating sta is a STA (in an infrastructured network):
+   * If aggregating STA is a non-AP STA (in an infrastructure network):
    *   SA = Address2
-   * If aggregating sta is an AP
+   * If aggregating STA is an AP
    *   SA = Address3
    *
    * \param hdr Wi-Fi header
@@ -451,9 +427,9 @@
   Mac48Address MapSrcAddressForAggregation (const WifiMacHeader &hdr);
   /**
    * This functions are used only to correctly set destination address in A-MSDU subframes.
-   * If aggregating sta is a STA (in an infrastructured network):
+   * If aggregating STA is a non-AP STA (in an infrastructure network):
    *   DA = Address3
-   * If aggregating sta is an AP
+   * If aggregating STA is an AP
    *   DA = Address1
    *
    * \param hdr Wi-Fi header
@@ -466,33 +442,35 @@
   /// allow AggregationCapableTransmissionListener class access
   friend class AggregationCapableTransmissionListener;
 
+  // Overridden from Txop
+  void DoDispose (void);
+  void DoInitialize (void);
+  void TerminateTxop (void);
+  uint32_t GetNextFragmentSize (void) const;
+  uint32_t GetFragmentSize (void) const;
+  uint32_t GetFragmentOffset (void) const;
+  bool IsLastFragment (void) const;
+
   /**
    * If number of packets in the queue reaches m_blockAckThreshold value, an ADDBA Request frame
    * is sent to destination in order to setup a block ack.
    *
-   * \return true if we tried to set up block ACK, false otherwise.
+   * \return true if we tried to set up block ack, false otherwise.
    */
   bool SetupBlockAckIfNeeded (void);
   /**
-   * Sends an ADDBA Request to establish a block ack agreement with sta
-   * addressed by <i>recipient</i> for tid <i>tid</i>.
+   * Sends an ADDBA Request to establish a block ack agreement with STA
+   * addressed by <i>recipient</i> for TID <i>tid</i>.
    *
    * \param recipient address of the recipient.
    * \param tid traffic ID.
    * \param startSeq starting sequence.
    * \param timeout timeout value.
-   * \param immediateBAck flag to indicate whether immediate block ack is used.
+   * \param immediateBAck flag to indicate whether immediate BlockAck is used.
    */
   void SendAddBaRequest (Mac48Address recipient, uint8_t tid, uint16_t startSeq,
                          uint16_t timeout, bool immediateBAck);
   /**
-   * After that all packets, for which a block ack agreement was established, have been
-   * transmitted, we have to send a block ack request.
-   *
-   * \param bar the block ack request.
-   */
-  void SendBlockAckRequest (const Bar &bar);
-  /**
    * Check if the given MPDU is to be considered old according to the current
    * starting sequence number of the transmit window, provided that a block ack
    * agreement has been established with the recipient for the given TID.
@@ -501,52 +479,6 @@
    * \return true if the MPDU is to be considered old, false otherwise
    */
   bool IsQosOldPacket (Ptr<const WifiMacQueueItem> mpdu);
-  /**
-   * For now is typically invoked to complete transmission of a packets sent with ack policy
-   * Block Ack: the packet is buffered and dcf is reset.
-   */
-  void CompleteTx (void);
-  /**
-   * Verifies if dequeued packet has to be transmitted with ack policy Block Ack. This happens
-   * if an established block ack agreement exists with the receiver.
-   */
-  void VerifyBlockAck (void);
-  /**
-   * Return the remaining duration in the current TXOP.
-   *
-   * \return the remaining duration in the current TXOP.
-   */
-  Time GetTxopRemaining (void) const;
-  /**
-   * Update backoff and restart access if needed.
-   */
-  void TerminateTxop (void);
-
-  /**
-   * Calculate the size of the next fragment.
-   *
-   * \return the size of the next fragment.
-   */
-  uint32_t GetNextFragmentSize (void) const;
-  /**
-   * Calculate the size of the current fragment.
-   *
-   * \return the size of the current fragment.
-   */
-  uint32_t GetFragmentSize (void) const;
-  /**
-   * Calculate the offset for the current fragment.
-   *
-   * \return the offset for the current fragment.
-   */
-  uint32_t GetFragmentOffset (void) const;
-  /**
-   * Check if the current fragment is the last fragment.
-   *
-   * \return true if the current fragment is the last fragment,
-   *         false otherwise.
-   */
-  bool IsLastFragment (void) const;
 
   /**
    * Check if the current packet is fragmented because of an exceeded TXOP duration.
@@ -558,7 +490,7 @@
   /**
    * Calculate the size of the current TXOP fragment.
    *
-   * \return the size of the current TXOP fragment
+   * \return the size of the current TXOP fragment in bytes
    */
   uint32_t GetTxopFragmentSize (void) const;
   /**
@@ -571,14 +503,14 @@
    * Calculate the size of the next TXOP fragment.
    *
    * \param fragmentNumber number of the next fragment
-   * \returns the next TXOP fragment size
+   * \returns the next TXOP fragment size in bytes
    */
   uint32_t GetNextTxopFragmentSize (uint32_t fragmentNumber) const;
   /**
    * Calculate the offset for the fragment.
    *
    * \param fragmentNumber number of the fragment
-   * \returns the TXOP fragment offset
+   * \returns the TXOP fragment offset in bytes
    */
   uint32_t GetTxopFragmentOffset (uint32_t fragmentNumber) const;
   /**
@@ -596,24 +528,23 @@
    */
   void ResetBa (Mac48Address recipient, uint8_t tid);
 
-  void DoDispose (void);
-  void DoInitialize (void);
-
   AcIndex m_ac;                                         //!< the access category
   TypeOfStation m_typeOfStation;                        //!< the type of station
-  Ptr<QosBlockedDestinations> m_qosBlockedDestinations; //!< QOS blocked destinations
-  Ptr<BlockAckManager> m_baManager;                     //!< the Block ACK manager
-  uint8_t m_blockAckThreshold;                          //!< the Block ACK threshold
-  BlockAckType m_blockAckType;                          //!< the Block ACK type
+  Ptr<WifiAckPolicySelector> m_ackPolicySelector;       //!< the ack policy selector
+  Ptr<QosBlockedDestinations> m_qosBlockedDestinations; //!< the QoS blocked destinations
+  Ptr<BlockAckManager> m_baManager;                     //!< the block ack manager
+  uint8_t m_blockAckThreshold;                          /**< the block ack threshold (use BA mechanism if number of packets in queue reaches
+                                                             this value. If this value is 0, block ack is never used. When A-MPDU is enabled,
+                                                             block ack mechanism is used regardless of this value) */
+  BlockAckType m_blockAckType;                          //!< the BlockAck type
   Time m_currentPacketTimestamp;                        //!< the current packet timestamp
-  uint16_t m_blockAckInactivityTimeout;                 //!< the Block ACK inactivity timeout
-  Bar m_currentBar;                                     //!< the current BAR
+  uint16_t m_blockAckInactivityTimeout;                 //!< the BlockAck inactivity timeout value (in TUs, i.e. blocks of 1024 microseconds)
   Time m_startTxop;                                     //!< the start TXOP time
   bool m_isAccessRequestedForRts;                       //!< flag whether access is requested to transmit a RTS frame
   bool m_currentIsFragmented;                           //!< flag whether current packet is fragmented
   Time m_addBaResponseTimeout;                          //!< timeout for ADDBA response
   Time m_failedAddBaTimeout;                            //!< timeout after failed BA agreement
-  bool m_useExplicitBarAfterMissedBlockAck;             //!< flag whether explicit Block Ack Request should be sent upon missed Block Ack Response
+  bool m_useExplicitBarAfterMissedBlockAck;             //!< flag whether explicit BlockAckRequest should be sent upon missed BlockAck Response
 
   TracedCallback<Time, Time> m_txopTrace; //!< TXOP trace callback
 };
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/qos-utils.cc ns-3.31/src/wifi/model/qos-utils.cc
--- ns-3.30.1/src/wifi/model/qos-utils.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/qos-utils.cc	2020-06-27 17:38:30.000000000 -0700
@@ -127,7 +127,7 @@
             {
             case WifiActionHeader::BLOCK_ACK_ADDBA_REQUEST:
               {
-                MgtAddBaResponseHeader reqHdr;
+                MgtAddBaRequestHeader reqHdr;
                 pkt->RemoveHeader (reqHdr);
                 return reqHdr.GetTid ();
               }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/qos-utils.h ns-3.31/src/wifi/model/qos-utils.h
--- ns-3.30.1/src/wifi/model/qos-utils.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/qos-utils.h	2020-06-27 17:38:30.000000000 -0700
@@ -62,7 +62,7 @@
 
 /**
  * \ingroup wifi
- * If a qos tag is attached to the packet, returns a value < 8.
+ * If a QoS tag is attached to the packet, returns a value < 8.
  * A value >= 8 is returned otherwise.
  *
  * \param packet the packet to checked for a QoS tag
@@ -79,7 +79,7 @@
  * (see section 9.10.3 in IEEE 802.11e) packets must be forwarded up before "new" packets.
  *
  * \param seqControl the sequence control field
- * \param endSequence
+ * \param endSequence the sequence number ending the acknowledgment window
  *
  * \return a unique integer for the given sequence control and end sequence
  */
@@ -131,54 +131,54 @@
  * \param packet packet to check
  * \param hdr 802.11 header for packet to check
  *
- * Returns Tid of different packet types
+ * Returns TID of different packet types
  */
 uint8_t GetTid (Ptr<const Packet> packet, const WifiMacHeader hdr);
 
-  /**
-   * \ingroup wifi
-   * \brief Determine the tx queue for a given packet
-   * \param item the packet
-   * \returns the access category
-   *
-   * Modelled after the Linux function ieee80211_select_queue (net/mac80211/wme.c).
-   * A SocketPriority tag is attached to the packet (or the existing one is
-   * replaced) to carry the user priority, which is set to the three most
-   * significant bits of the DS field (TOS field in case of IPv4 and Traffic
-   * Class field in case of IPv6). The Access Category corresponding to the
-   * user priority according to the QosUtilsMapTidToAc function is returned.
-   *
-   * The following table shows the mapping for the Diffserv Per Hop Behaviors.
-   *
-   * PHB  | TOS (binary) | UP  | Access Category
-   * -----|--------------|-----|-----------------
-   * EF   |   101110xx   |  5  |     AC_VI
-   * AF11 |   001010xx   |  1  |     AC_BK
-   * AF21 |   010010xx   |  2  |     AC_BK
-   * AF31 |   011010xx   |  3  |     AC_BE
-   * AF41 |   100010xx   |  4  |     AC_VI
-   * AF12 |   001100xx   |  1  |     AC_BK
-   * AF22 |   010100xx   |  2  |     AC_BK
-   * AF32 |   011100xx   |  3  |     AC_BE
-   * AF42 |   100100xx   |  4  |     AC_VI
-   * AF13 |   001110xx   |  1  |     AC_BK
-   * AF23 |   010110xx   |  2  |     AC_BK
-   * AF33 |   011110xx   |  3  |     AC_BE
-   * AF43 |   100110xx   |  4  |     AC_VI
-   * CS0  |   000000xx   |  0  |     AC_BE
-   * CS1  |   001000xx   |  1  |     AC_BK
-   * CS2  |   010000xx   |  2  |     AC_BK
-   * CS3  |   011000xx   |  3  |     AC_BE
-   * CS4  |   100000xx   |  4  |     AC_VI
-   * CS5  |   101000xx   |  5  |     AC_VI
-   * CS6  |   110000xx   |  6  |     AC_VO
-   * CS7  |   111000xx   |  7  |     AC_VO
-   *
-   * This method is called by the traffic control layer before enqueuing a
-   * packet in the queue disc, if a queue disc is installed on the outgoing
-   * device, or passing a packet to the device, otherwise.
-   */
-  uint8_t SelectQueueByDSField (Ptr<QueueItem> item);
+/**
+ * \ingroup wifi
+ * \brief Determine the TX queue for a given packet
+ * \param item the packet
+ * \returns the access category
+ *
+ * Modeled after the Linux function ieee80211_select_queue (net/mac80211/wme.c).
+ * A SocketPriority tag is attached to the packet (or the existing one is
+ * replaced) to carry the user priority, which is set to the three most
+ * significant bits of the DS field (TOS field in case of IPv4 and Traffic
+ * Class field in case of IPv6). The Access Category corresponding to the
+ * user priority according to the QosUtilsMapTidToAc function is returned.
+ *
+ * The following table shows the mapping for the Diffserv Per Hop Behaviors.
+ *
+ * PHB  | TOS (binary) | UP  | Access Category
+ * -----|--------------|-----|-----------------
+ * EF   |   101110xx   |  5  |     AC_VI
+ * AF11 |   001010xx   |  1  |     AC_BK
+ * AF21 |   010010xx   |  2  |     AC_BK
+ * AF31 |   011010xx   |  3  |     AC_BE
+ * AF41 |   100010xx   |  4  |     AC_VI
+ * AF12 |   001100xx   |  1  |     AC_BK
+ * AF22 |   010100xx   |  2  |     AC_BK
+ * AF32 |   011100xx   |  3  |     AC_BE
+ * AF42 |   100100xx   |  4  |     AC_VI
+ * AF13 |   001110xx   |  1  |     AC_BK
+ * AF23 |   010110xx   |  2  |     AC_BK
+ * AF33 |   011110xx   |  3  |     AC_BE
+ * AF43 |   100110xx   |  4  |     AC_VI
+ * CS0  |   000000xx   |  0  |     AC_BE
+ * CS1  |   001000xx   |  1  |     AC_BK
+ * CS2  |   010000xx   |  2  |     AC_BK
+ * CS3  |   011000xx   |  3  |     AC_BE
+ * CS4  |   100000xx   |  4  |     AC_VI
+ * CS5  |   101000xx   |  5  |     AC_VI
+ * CS6  |   110000xx   |  6  |     AC_VO
+ * CS7  |   111000xx   |  7  |     AC_VO
+ *
+ * This method is called by the traffic control layer before enqueuing a
+ * packet in the queue disc, if a queue disc is installed on the outgoing
+ * device, or passing a packet to the device, otherwise.
+ */
+uint8_t SelectQueueByDSField (Ptr<QueueItem> item);
 
 } //namespace ns3
 
